﻿class com.macromedia.timeentry.Application extends mx.screens.Form {
	
	var frmTimeEntry:com.macromedia.timeentry.TimeEntry;
	var frmProject:com.macromedia.timeentry.Project;
	var frmClient:com.macromedia.timeentry.Client;
	var frmLog:com.macromedia.timeentry.Log;
	var mnuTimeEntry:mx.controls.MenuBar;
	var btnTimeEntry:Button;
	var btnProject:Button;
	var btnClient:Button;
	var btnLog:Button;

	/**
	  initialize class. 
	*/
	function Application() {
		addEventListener("load", onLoad);
	}

	/**
	  look at the selected property of the "offline" menu item.  Returns true if data should be loaded from shared object
	*/
	function getDataOffline():Boolean {
		return(mnuTimeEntry.getMenuAt(2).getMenuItemAt(0).attributes.selected);
	}
	
	/**
	  initialize components that live within this form.  Setup listeners for events that I am interested in 
	  responding to within the context of the Application class.
	*/
	function onLoad():Void {
		btnTimeEntry.onRelease = function() { _parent.toolbarHandler(this); }
		btnProject.onRelease = function() { _parent.toolbarHandler(this); }
		btnClient.onRelease = function() { _parent.toolbarHandler(this); }
		btnLog.onRelease = function() { _parent.toolbarHandler(this); }
		setupForm();
	}

	/**
	  Set the "Update Log" toolbar item to visible based on the users selection in the menu.
	*/
	function mnuViewChange(evt:Object):Void {
		btnLog._visible = evt.menuItem.attributes.selected;
	}

	/**
	  Create the global menu items for this appplication.
	*/
	function loadMenu():Void {
		//create view menu
		var mnuView:mx.controls.Menu = mnuTimeEntry.getMenuAt(1);
		mnuView.addMenuItem({label:"Update Log", type:"check", instanceName:"mnuViewLog", selected:false});
		mnuView.addEventListener("change", function(evt:Object) { evt.menuBar._parent.mnuViewChange(evt); } );

		//create setting menu
		var mnuSettings:mx.controls.Menu = mnuTimeEntry.getMenuAt(2);
		mnuSettings.addMenuItem({label:"Work offline", type:"check", instanceName:"mnuWorkOffline", selected:false});
	}

	/**
	  Initialize visual aspects of form.
	*/
	function setupForm():Void {
		loadMenu();
		btnLog._visible = false;
	}
	
	/**
	  This function is called each time a new toolbar item is selected.  It sets the visibility of the associated forms
	  so that the user is given the appearance of working with a tabbed notebook.
	*/
	function toolbarHandler(btn:Button):Void {
		frmTimeEntry.visible = (btn == btnTimeEntry);
		frmProject.visible = (btn == btnProject);	
		frmClient.visible = (btn == btnClient);
		frmLog.visible = (btn == btnLog);
	}
		
		
}